{"swagger":"2.0","info":{"version":"1.4.1","title":"1A_REST_JSON_Distribution_Strategy","description":"This document describes how to use the Amadeus hotel distribution strategy REST API. The Existing code mappings have been extended to include distribution-strategy as well to define distributions for a vendor. This Distribution strategy API is to manage Distribution strategy for a vendor and it covers distributed properties for a vendor and distributed offers for a vendor and property. Provides the BE data for the user channel manager(s) to view a report that will show different rate plans and inventory types published to various partners, along with the date/time of publication if some publications are scheduled during a specific period.","x-release-note":{"1.0.0":["The addition of property distribution attributes to the existing definition, which will define the distribution of properties per vendor.","Addition of POST and GET service defined for property distribution. Property distribution will replace the existing property code-mappings.","New service defined for Distributed Offers (GET & POST).","PUT & DELETE operations defined for Distributed properties.","PATCH & DELETE operations defined for distributed offers."],"1.0.1":["offer isActive flag updated as mandatory."],"1.1.0":["Added notification (POST) service."],"1.2.0":["######### New in Request & Response ################","ratePlanDistribution.ratePlanName- DistributedOffers","ratePlanDistribution.longRateDescription- DistributedOffers","ratePlanDistribution.shortRateDescription- DistributedOffers","ratePlanDistribution.bookingMessage- DistributedOffers","inventoryTypeDistribution.inventoryTypeName- DistributedOffers","inventoryTypeDistribution.inventoryTyeDescription- DistributedOffers","ratePlanDistribution.sequence- DistributedOffers","ratePlanDistribution.isPublic- DistributedOffers","ratePlanDistribution.pairedARIRatePlanCode- DistributedOffers","propertyDistribution.rateOverrideThreshold- DistributedProperties","######### Max Length updated ################","ratePlanDistribution.ratePlanCode {1,50} - DistributedOffers","inventoryTypeDistribution.inventoryTypeCode {2,50} - DistributedOffers","######### Max array items updated ###############","ratePlanDistributions[]maxItems:10000 - DistributedOffers","inventoryTypeDistributions[]maxItems:2000 - DistributedOffers","offers[]maxItems:2000 - DistributedOffers"],"1.3.0":["######### New in Request & Response #########","ratePlanDistribution.isActive- DistributedOffers","inventoryTypeDistribution.isActive- DistributedOffers","ratePlanDistribution.rateOverrideThreshold- DistributedOffers"],"1.4.0":["######### New Operation #########","/availability/chains/{chain_code}/distribution-strategy/retrieve-distribution-by-property  - provides the list of properties distributed for a chain with the distribution strategy set"],"1.4.1":["######### Other Changes #########","Cleanup of release note","rename operations"]}},"consumes":["application/json"],"produces":["application/json"],"schemes":["https"],"basePath":"/v1","tags":[{"name":"Distributed Offer"},{"name":"Distributed Property"},{"name":"Distribution Strategy"}],"parameters":{"chain_code":{"name":"chain_code","in":"path","required":true,"description":"unique identifier of a Chain","type":"string","pattern":"^[A-Z0-9]{2,3}$"},"vendor_code":{"name":"VendorCode","in":"path","required":true,"description":"unique identifier of a Vendor in a Chain","type":"string","pattern":"^[A-Z0-9]{5,5}$"},"propertyCode":{"name":"propertyCode","in":"path","required":true,"description":"unique identifier of a property","type":"string","pattern":"^[A-Z0-9]{1,8}$"},"vendor_code_query":{"name":"vendorCode","in":"query","required":false,"description":"unique identifier of a Vendor in a Chain","type":"string","pattern":"^[A-Z0-9]{5,5}$"},"version_query":{"name":"version","in":"query","required":false,"description":"version of the record","type":"integer"},"Ama-Client-Ref":{"name":"Ama-Client-Ref","in":"header","description":"Client traceability token","required":false,"type":"string"},"DistributedPropertyCreateRequest":{"name":"DistributedPropertyCreateRequest","in":"body","description":"property distribution records to create for a vendor","required":true,"schema":{"$ref":"#/definitions/DistributedPropertyCreateRequest"}},"DistributedOffersCreateRequest":{"name":"DistributedOffersCreateRequest","in":"body","description":"Creation of distributed offers per property for a vendor","required":true,"schema":{"$ref":"#/definitions/DistributedOffersCreateRequest"}},"DistributedOffersPartialUpdateRequest":{"name":"DOPartialUpdateRequest","in":"body","description":"Partial update of distributed offers per property for a vendor","required":true,"schema":{"$ref":"#/definitions/DOPartialUpdateRequest"}},"DistributedPropertyUpdateRequest":{"name":"DistributedPropertyUpdateRequest","in":"body","description":"property distribution records to create for a vendor","required":true,"schema":{"$ref":"#/definitions/DistributedPropertyUpdateRequest"}},"CmdNotifRequest":{"name":"CmdNotifRequest","in":"body","description":"Body parameter to notify channels of any change in distribution strategy","required":true,"schema":{"$ref":"#/definitions/CmdNotifRequest"}},"PropertyListDataRequest":{"name":"PropertyListDataRequest","in":"body","description":"List of properties for a chain to request the distribution data","required":false,"schema":{"$ref":"#/definitions/PropertyListDataRequest"}}},"paths":{"/hotel/code-mappings/{chain_code}/property-codes":{"post":{"tags":["Distributed Property"],"operationId":"postDistributedProperties","summary":"create-distributed-property","parameters":[{"$ref":"#/parameters/chain_code"},{"$ref":"#/parameters/Ama-Client-Ref"},{"$ref":"#/parameters/DistributedPropertyCreateRequest"}],"responses":{"201":{"description":"Created","schema":{"$ref":"#/definitions/DistributedPropertyCreateResponse"}},"400":{"description":"Bad Request\n\nExamples of functional error codes (not exhaustive list):\n\ncode    | title                                 \n------- | ------------------- \n320110  | Invalid message\n322316  | The Property {PropertyCode} is duplicated for the Vendor\n{VendorCode} in the same transaction\n322321  | The distribution property code {DistributionPropertyCode} is\nduplicated for the Vendor {VendorCode} in the same transaction\n","schema":{"$ref":"#/definitions/Errors"}},"403":{"description":"Forbidden\n\nExamples of functional error codes (not exhaustive list):\n\ncode    | title                                 \n------- | ------------------- \n320200  | You do not have permissions to perform the action requested\n","schema":{"$ref":"#/definitions/Errors"}},"409":{"description":"Conflict\n\nExamples of functional error codes (not exhaustive list):\n\ncode    | title                                 \n------- | ------------------- \n322341  | Distributed properties record exists for the vendor {vendorCode}\n","schema":{"$ref":"#/definitions/Errors"}},"500":{"description":"Internal Server Error\n\nExamples of functional error codes (not exhaustive list):\n\ncode    | title                                 \n------- | ------------------- \n322083  | Unexpected error occurred\n320303  | Error while trying to log your activity into the audit trail\n","schema":{"$ref":"#/definitions/Errors"}}}},"get":{"tags":["Distributed Property"],"operationId":"getDistributedProperties","summary":"retrieve-distributed-property","parameters":[{"$ref":"#/parameters/chain_code"},{"$ref":"#/parameters/Ama-Client-Ref"},{"$ref":"#/parameters/vendor_code_query"}],"responses":{"200":{"description":"OK","schema":{"$ref":"#/definitions/DistributedPropertyRetrieveResponse"}},"400":{"description":"Bad Request\n\nExamples of functional error codes (not exhaustive list):\n\ncode    | title                                 \n------- | ------------------- \n320110  | Invalid message\n","schema":{"$ref":"#/definitions/Errors"}},"403":{"description":"Forbidden\n\nExamples of functional error codes (not exhaustive list):\n\ncode    | title                                 \n------- | ------------------- \n320200  | You do not have permissions to perform the action requested\n","schema":{"$ref":"#/definitions/Errors"}},"404":{"description":"Not Found\n\nExamples of functional error codes (not exhaustive list):\n\ncode    | title                                 \n------- | ------------------- \n322338  | No distributed properties record found for the\nvendor{VendorCode}\n","schema":{"$ref":"#/definitions/Errors"}},"500":{"description":"Internal Server Error\n\nExamples of functional error codes (not exhaustive list):\n\ncode    | title                                 \n------- | ------------------- \n322083  | Unexpected error occurred\n","schema":{"$ref":"#/definitions/Errors"}}}},"delete":{"tags":["Distributed Property"],"operationId":"deleteDistributedProperties","summary":"delete-distributed-property","parameters":[{"$ref":"#/parameters/chain_code"},{"$ref":"#/parameters/Ama-Client-Ref"},{"$ref":"#/parameters/vendor_code_query"},{"$ref":"#/parameters/version_query"}],"responses":{"204":{"description":"OK","schema":{"$ref":"#/definitions/Warnings"}},"400":{"description":"Bad Request\n\nExamples of functional error codes (not exhaustive list):\n\ncode    | title                                 \n------- | ------------------- \n320110  | Invalid message\n322354  | vendor code and version must be present in the request\n","schema":{"$ref":"#/definitions/Errors"}},"403":{"description":"Forbidden\n\nExamples of functional error codes (not exhaustive list):\n\ncode    | title                                 \n------- | ------------------- \n320200  | You do not have permissions to perform the action requested\n","schema":{"$ref":"#/definitions/Errors"}},"404":{"description":"Not Found\n\nExamples of functional error codes (not exhaustive list):\n\ncode    | title                                 \n------- | ------------------- \n322338  | No distributed properties record found for the\nvendor{VendorCode}\n","schema":{"$ref":"#/definitions/Errors"}},"409":{"description":"Conflict\n\nExamples of functional error codes (not exhaustive list):\n\ncode    | title                                 \n------- | ------------------- \n322356  | Concurrent updates detected. Please try again\n","schema":{"$ref":"#/definitions/Errors"}},"500":{"description":"Internal Server Error\n\nExamples of functional error codes (not exhaustive list):\n\ncode    | title                                 \n------- | ------------------- \n322083  | Unexpected error occurred\n322355  | Distributed properties record was not deleted successfully\n320303  | Error while trying to log your activity into the audit trail\n","schema":{"$ref":"#/definitions/Errors"}}}},"put":{"tags":["Distributed Property"],"operationId":"putDistributedProperties","summary":"update-distributed-property","parameters":[{"$ref":"#/parameters/chain_code"},{"$ref":"#/parameters/Ama-Client-Ref"},{"$ref":"#/parameters/vendor_code_query"},{"$ref":"#/parameters/DistributedPropertyUpdateRequest"}],"responses":{"200":{"description":"OK","schema":{"$ref":"#/definitions/DistributedPropertyUpdateResponse"}},"400":{"description":"Bad Request\n\nExamples of functional error codes (not exhaustive list):\n\ncode    | title                                 \n------- | ------------------- \n320110  | Invalid message\n322316  | The Property {PropertyCode} is duplicated for the Vendor\n{VendorCode} in the same transaction\n322321  | The distribution property code {DistributionPropertyCode} is\nduplicated for the Vendor {VendorCode} in the same transaction\n322352  | vendor code must be present in the request\n","schema":{"$ref":"#/definitions/Errors"}},"403":{"description":"Forbidden\n\nExamples of functional error codes (not exhaustive list):\n\ncode    | title                                 \n------- | ------------------- \n320200  | You do not have permissions to perform the action requested\n","schema":{"$ref":"#/definitions/Errors"}},"404":{"description":"Not Found\n\nExamples of functional error codes (not exhaustive list):\n\ncode    | title                                 \n------- | ------------------- \n322338  | No distributed properties record found for the\nvendor{VendorCode}\n","schema":{"$ref":"#/definitions/Errors"}},"409":{"description":"Conflict\n\nExamples of functional error codes (not exhaustive list):\n\ncode    | title                                 \n------- | ------------------- \n322356  | Concurrent updates detected. Please try again\n","schema":{"$ref":"#/definitions/Errors"}},"500":{"description":"Internal Server Error\n\nExamples of functional error codes (not exhaustive list):\n\ncode    | title                                 \n------- | ------------------- \n322083  | Unexpected error occurred\n322353  | Distributed properties record was not deleted successfully\n320303  | Error while trying to log your activity into the audit trail\n","schema":{"$ref":"#/definitions/Errors"}}}}},"/availability/chains/{chain_code}/vendors/{VendorCode}/properties/{propertyCode}/distributed-offers":{"post":{"tags":["Distributed Offer"],"summary":"create-distributed-offer","operationId":"create-distributed-offer","parameters":[{"$ref":"#/parameters/chain_code"},{"$ref":"#/parameters/vendor_code"},{"$ref":"#/parameters/propertyCode"},{"$ref":"#/parameters/Ama-Client-Ref"},{"$ref":"#/parameters/DistributedOffersCreateRequest"}],"responses":{"201":{"description":"Created","schema":{"$ref":"#/definitions/Warnings"}},"400":{"description":"Bad Request\n\nExamples of functional error codes (not exhaustive list):\n\ncode    | title                                 \n------- | ------------------- \n320110  | Invalid message\n322345  | Rate plan(s) is/are duplicated in the same transaction  \n322346  | Inventory type(s) is/are duplicated in the inventory type distribution in the same transaction\n322350  | Inventory type(s) is/are duplicated in the inventory exceptions in the same transaction\n322348  | A distributed offers record already exists for the vendor and property\n322347  | Distribution period should be valid and should be in the YYYY-MM-DDThh:mm:ssZ format\n322351  | Property is not distributed for the given vendor in the request\n","schema":{"$ref":"#/definitions/Errors"}},"403":{"description":"Forbidden\n\nExamples of functional error codes (not exhaustive list):\n\ncode    | title                                 \n------- | ------------------- \n320200  | You do not have permissions to perform the action requested\n","schema":{"$ref":"#/definitions/Errors"}},"500":{"description":"Internal Server Error\n\nExamples of functional error codes (not exhaustive list):\n\ncode    | title                                 \n------- | ------------------- \n322083  | Unexpected error occurred\n320303  | Error while trying to log your activity into the audit trail\n","schema":{"$ref":"#/definitions/Errors"}}}},"get":{"tags":["Distributed Offer"],"summary":"retrieve-distributed-offer","operationId":"retrieve-distributed-offer","parameters":[{"$ref":"#/parameters/chain_code"},{"$ref":"#/parameters/Ama-Client-Ref"},{"$ref":"#/parameters/vendor_code"},{"$ref":"#/parameters/propertyCode"}],"responses":{"200":{"description":"OK","schema":{"$ref":"#/definitions/DistributedOffersRetrieveResponse"}},"400":{"description":"Bad Request\n\nExamples of functional error codes (not exhaustive list):\n\ncode    | title                                 \n------- | ------------------- \n320110  | Invalid message\n","schema":{"$ref":"#/definitions/Errors"}},"403":{"description":"Forbidden\n\nExamples of functional error codes (not exhaustive list):\n\ncode    | title                                 \n------- | ------------------- \n320200  | You do not have permissions to perform the action requested\n","schema":{"$ref":"#/definitions/Errors"}},"404":{"description":"Not Found\n\nExamples of functional error codes (not exhaustive list):\n\ncode    | title                                 \n------- | ------------------- \n322349  | No distributed offers record found for the vendor and property\n","schema":{"$ref":"#/definitions/Errors"}},"500":{"description":"Internal Server Error\n\nExamples of functional error codes (not exhaustive list):\n\ncode    | title                                 \n------- | ------------------- \n322083  | Unexpected error occurred\n","schema":{"$ref":"#/definitions/Errors"}}}},"patch":{"tags":["Distributed Offer"],"operationId":"PartialUpdateDistributedOffers","summary":"partial-update-distributed-offer","parameters":[{"$ref":"#/parameters/chain_code"},{"$ref":"#/parameters/vendor_code"},{"$ref":"#/parameters/propertyCode"},{"$ref":"#/parameters/Ama-Client-Ref"},{"$ref":"#/parameters/DistributedOffersPartialUpdateRequest"}],"responses":{"200":{"description":"OK","schema":{"$ref":"#/definitions/DOPartialUpdateResponse"}},"400":{"description":"Bad Request\n\nExamples of functional error codes (not exhaustive list):\n\ncode    | title                                 \n------- | ------------------- \n320110  | Invalid message\n322345  | Rate plan(s) is/are duplicated in the same transaction  \n322346  | Inventory type(s) is/are duplicated in the inventory type\ndistribution in the same transaction\n","schema":{"$ref":"#/definitions/Errors"}},"403":{"description":"Forbidden\n\nExamples of functional error codes (not exhaustive list):\n\ncode    | title                                 \n------- | ------------------- \n320200  | You do not have permissions to perform the action requested\n","schema":{"$ref":"#/definitions/Errors"}},"404":{"description":"Not Found\n\nExamples of functional error codes (not exhaustive list):\n\ncode    | title                                 \n------- | ------------------- \n322349  | No distributed offers record found for the vendor and property\n","schema":{"$ref":"#/definitions/Errors"}},"409":{"description":"Conflict\n\nExamples of functional error codes (not exhaustive list):\n\ncode    | title                                 \n------- | ------------------- \n322356  | Concurrent updates detected. Please try again\n","schema":{"$ref":"#/definitions/Errors"}},"500":{"description":"Internal Server Error\n\nExamples of functional error codes (not exhaustive list):\n\ncode    | title                                 \n------- | ------------------- \n322083  | Unexpected error occurred\n320303  | Error while trying to log your activity into the audit trail\n","schema":{"$ref":"#/definitions/Errors"}}}},"delete":{"tags":["Distributed Offer"],"operationId":"DeleteDistributedOffers","summary":"delete-distributed-offer","parameters":[{"$ref":"#/parameters/chain_code"},{"$ref":"#/parameters/vendor_code"},{"$ref":"#/parameters/propertyCode"},{"$ref":"#/parameters/Ama-Client-Ref"},{"$ref":"#/parameters/version_query"}],"responses":{"204":{"description":"OK","schema":{"$ref":"#/definitions/Warnings"}},"400":{"description":"Bad Request\n\nExamples of functional error codes (not exhaustive list):\n\ncode    | title                                 \n------- | ------------------- \n320110  | Invalid message\n322364  | The version must be present in the request\n","schema":{"$ref":"#/definitions/Errors"}},"403":{"description":"Forbidden\n\nExamples of functional error codes (not exhaustive list):\n\ncode    | title                                 \n------- | ------------------- \n320200  | You do not have permissions to perform the action requested\n","schema":{"$ref":"#/definitions/Errors"}},"404":{"description":"Not Found\n\nExamples of functional error codes (not exhaustive list):\n\ncode    | title                        \n------- | ------------------- \n322349  | No distributed offers record found for the vendor and property\n","schema":{"$ref":"#/definitions/Errors"}},"409":{"description":"Conflict\n\nExamples of functional error codes (not exhaustive list):\n\ncode    | title                                 \n------- | ------------------- \n322356  | Concurrent updates detected. Please try again\n","schema":{"$ref":"#/definitions/Errors"}},"500":{"description":"Internal Server Error\n\nExamples of functional error codes (not exhaustive list):\n\ncode    | title                                 \n------- | ------------------- \n322083  | Unexpected error occurred\n320303  | Error while trying to log your activity into the audit trail\n","schema":{"$ref":"#/definitions/Errors"}}}}},"/availability/chains/{chain_code}/distribution-strategy/notification":{"post":{"tags":["Distribution Strategy"],"operationId":"NotificationDistributionStrategy","summary":"notify-change","parameters":[{"$ref":"#/parameters/chain_code"},{"$ref":"#/parameters/Ama-Client-Ref"},{"$ref":"#/parameters/CmdNotifRequest"}],"responses":{"200":{"description":"OK","schema":{"$ref":"#/definitions/CmdNotifResponse"}},"400":{"description":"Bad Request\n\nExamples of functional error codes (not exhaustive list):\n\ncode    | title                                 \n------- | ------------------- \n320110  | Invalid message\n","schema":{"$ref":"#/definitions/Errors"}},"403":{"description":"Forbidden\n\nExamples of functional error codes (not exhaustive list):\n\ncode    | title                                 \n------- | ------------------- \n320200  | The user is not authorised to perform the action\n","schema":{"$ref":"#/definitions/Errors"}},"500":{"description":"Internal Server Error\n\nExamples of functional error codes (not exhaustive list):\n\ncode    | title                                 \n------- | ------------------- \n322083  | Unexpected error occurred\n","schema":{"$ref":"#/definitions/Errors"}}}}},"/availability/chains/{chain_code}/distribution-strategy/retrieve-distribution-by-property":{"post":{"tags":["Distribution Strategy"],"summary":"retrieve-distribution-strategy-by-property","operationId":"RetrieveDistributionDataPerProperty","parameters":[{"$ref":"#/parameters/chain_code"},{"$ref":"#/parameters/Ama-Client-Ref"},{"$ref":"#/parameters/PropertyListDataRequest"}],"responses":{"200":{"description":"OK","schema":{"$ref":"#/definitions/PropertyListDataResponse"}},"400":{"description":"Bad Request\n\nExamples of functional error codes (not exhaustive list):\n\ncode    | title                                 \n------- | ------------------- \n320110  | Invalid message\n","schema":{"$ref":"#/definitions/Errors"}},"403":{"description":"Forbidden\n\nExamples of functional error codes (not exhaustive list):\n\ncode    | title                                 \n------- | ------------------- \n320200  | You do not have permissions to perform the action requested\n","schema":{"$ref":"#/definitions/Errors"}},"500":{"description":"Internal Server Error\n\nExamples of functional error codes (not exhaustive list):\n\ncode    | title                                 \n------- | ------------------- \n322083  | Unexpected error occurred\n","schema":{"$ref":"#/definitions/Errors"}}}}}},"definitions":{"CmdNotifRequest":{"additionalProperties":false,"description":"All data for the CM Direct Dynamic Notification","properties":{"data":{"properties":{"conversationId":{"$ref":"#/definitions/conversationId"},"events":{"$ref":"#/definitions/cmdNotifications"}},"required":["events"],"title":"cmdNotifRequestData","type":"object"}},"required":["data"],"type":"object"},"CmdNotifResponse":{"additionalProperties":false,"description":"Response object for CM Direct notification","properties":{"conversationId":{"$ref":"#/definitions/conversationId"},"data":{"properties":{"success":{"$ref":"#/definitions/success"}},"required":["success"],"title":"cmdNotifResponseData","type":"object"},"warnings":{"items":{"$ref":"#/definitions/Warning"},"maxItems":999,"type":"array"}},"type":"object"},"DOPartialUpdateRequest":{"additionalProperties":false,"properties":{"data":{"$ref":"#/definitions/partialUpdateForDistributedOffers"}},"required":["data"],"type":"object"},"DOPartialUpdateResponse":{"additionalProperties":false,"description":"Partial Update distributed offers response","properties":{"data":{"properties":{"version":{"$ref":"#/definitions/version"}},"required":["version"],"title":"DistOffersPartialUpdateResponseData","type":"object"},"warnings":{"items":{"$ref":"#/definitions/Warning"},"maxItems":999,"type":"array"}},"required":["data"],"type":"object"},"DistributedOffersCreateRequest":{"additionalProperties":false,"properties":{"data":{"$ref":"#/definitions/createForDistributedOffers"}},"required":["data"],"type":"object"},"DistributedOffersRetrieveResponse":{"additionalProperties":false,"description":"Retrieve Distributed offers per property response body","properties":{"data":{"properties":{"inventoryTypeDistributions":{"$ref":"#/definitions/InventoryTypeDistributions"},"ratePlanDistributions":{"$ref":"#/definitions/RatePlanDistributions"},"version":{"$ref":"#/definitions/version"}},"required":["version"],"title":"DistributedOffersRetrieveResponseData","type":"object"}},"required":["data"],"type":"object"},"DistributedPropertyCreateRequest":{"additionalProperties":false,"properties":{"data":{"$ref":"#/definitions/createForDistributedProperty"}},"required":["data"],"type":"object"},"DistributedPropertyCreateResponse":{"additionalProperties":false,"description":"Create distributed properties response","properties":{"vendorCode":{"$ref":"#/definitions/VendorCode"},"warnings":{"items":{"$ref":"#/definitions/Warning"},"maxItems":999,"type":"array"}},"required":["vendorCode"],"type":"object"},"DistributedPropertyRetrieveResponse":{"additionalProperties":false,"description":"Retrieve Distributed Property response","properties":{"data":{"properties":{"propertyDistribution":{"$ref":"#/definitions/PropertyDistribution"},"vendorCode":{"$ref":"#/definitions/VendorCode"},"version":{"$ref":"#/definitions/version"}},"required":["propertyDistribution","vendorCode","version"],"title":"DistributedPropertyRetrieveResponseData","type":"object"}},"required":["data"],"type":"object"},"DistributedPropertyUpdateRequest":{"additionalProperties":false,"properties":{"data":{"$ref":"#/definitions/updateForDistributedProperty"}},"required":["data"],"type":"object"},"DistributedPropertyUpdateResponse":{"additionalProperties":false,"description":"Update distributed properties response","properties":{"data":{"properties":{"version":{"$ref":"#/definitions/version"}},"required":["version"],"title":"DistPropertyUpdateResponseData","type":"object"},"warnings":{"items":{"$ref":"#/definitions/Warning"},"maxItems":999,"type":"array"}},"required":["data"],"type":"object"},"DistributionInventoryTypeCode":{"description":"code used by external channel to identify an inventory type","example":"ABCDE","pattern":"^[A-Z0-9]{1,16}$","type":"string"},"DistributionPeriod":{"description":"Date-Time period the distributed offer is applicable","properties":{"endDateTime":{"description":"end date & time","example":"2020-05-15T05:25:41Z","format":"date-time","type":"string"},"startDateTime":{"description":"start date & time","example":"2020-05-15T05:25:41Z","format":"date-time","type":"string"}},"required":["startDateTime","endDateTime"],"type":"object"},"DistributionPropertyCode":{"description":"code used by external channel to identify a property","example":"ABCDE","pattern":"^[A-Z0-9]{1,16}$","type":"string"},"DistributionRatePlanCode":{"description":"code used by external channel to identify a rate plan","example":"ABCDE","pattern":"^[A-Z0-9]{1,16}$","type":"string"},"Error":{"properties":{"code":{"description":"A machine-readable error code from the Amadeus Canned Messages table, that will enable the API Consumers code to handle this type of error","example":300200,"type":"integer"},"detail":{"description":"An easy-to-read explanation specific to this occurrence of the problem. It should give the API consumer an idea of what went wrong and how to recover from it. Like the title, this field�s value can be localize","example":"Property code missing","type":"string"},"source":{"$ref":"#/definitions/ErrorSource"},"status":{"description":"The [HTTP status code](https://www.iana.org/assignments/http-status-codes/http-status-codes.xhtml) of this response. This is present only in terminal errors which cause an unsuccessful response. In the case of multiple errors, they must all have the same status.","example":400,"type":"integer"},"title":{"description":"An error title from the Canned Messages table with a 1:1 correspondence to the error code. This may be localized","example":"Invalid Message","type":"string"}},"required":["status","code","title"],"type":"object"},"ErrorSource":{"description":"An object containing references to the source of the error","properties":{"example":{"description":"A sample input to guide the user when resolving this issue","example":"Property code usually a 5 character code","type":"string"},"parameter":{"description":"The key of the URI path or query parameter that caused the error","example":"PTY01","type":"string"},"pointer":{"description":"A JSON Pointer [RFC6901] to the associated entity in the request body that caused this error","type":"string"}},"type":"object"},"Errors":{"properties":{"errors":{"items":{"$ref":"#/definitions/Error"},"minItems":1,"type":"array"}},"type":"object"},"InventoryTypeCode":{"description":"inventory type code","example":"PARINVTYPE001","pattern":"^[A-Z0-9]{2,50}$","type":"string"},"InventoryTypeDistributions":{"description":"inventory type distribution list","items":{"properties":{"distributionInventoryTypeCode":{"$ref":"#/definitions/DistributionInventoryTypeCode"},"inventoryTypeCode":{"$ref":"#/definitions/InventoryTypeCode"},"inventoryTypeDescription":{"$ref":"#/definitions/inventoryDescription","description":"Description of the inventory type"},"inventoryTypeName":{"$ref":"#/definitions/name","description":"Name of the inventory type"},"isActive":{"$ref":"#/definitions/isActive","description":"if true indicates that the inventory type is active for distribution"}},"required":["inventoryTypeCode"],"title":"InventoryTypeDistribution","type":"object"},"maxItems":2000,"minItems":1,"type":"array","uniqueItems":true},"MaxOccupancy":{"description":"Maximum allowed occupancy for an inventory OR rate plan type","example":6,"maximum":99,"minimum":1,"type":"integer"},"ModificationChanges":{"description":"List of changes for a modification request","items":{"properties":{"op":{"$ref":"#/definitions/op"},"path":{"$ref":"#/definitions/path"},"value":{"$ref":"#/definitions/value"}},"required":["op","path"],"title":"modificationChange","type":"object"},"type":"array","uniqueItems":true},"Offers":{"description":"Inventory type offer exceptions","items":{"properties":{"inventoryTypeCode":{"$ref":"#/definitions/InventoryTypeCode"},"isActive":{"$ref":"#/definitions/isActive","description":"if true indicates that the offer is active for distribution"},"maxOccupancy":{"$ref":"#/definitions/MaxOccupancy"}},"required":["inventoryTypeCode","isActive"],"title":"Offer","type":"object"},"maxItems":2000,"minItems":1,"type":"array","uniqueItems":true},"PropertyCode":{"description":"unique identifier of a Property in a Chain or a Brand","example":"NCECT","pattern":"^[A-Z0-9]{1,8}$","type":"string"},"PropertyDistribution":{"description":"Property distribution list","items":{"properties":{"distributionPropertyCode":{"$ref":"#/definitions/DistributionPropertyCode"},"propertyCode":{"$ref":"#/definitions/PropertyCode"},"rateOverrideThreshold":{"$ref":"#/definitions/rateOverrideThreshold","description":"If authorized, a user can define a threshold (% of the price) per property per channel that represent the tolerance of rate discrepancy between the CRS and the channel. The threshold is a percentage on the base rate"}},"required":["propertyCode"],"title":"PropertyDistribution","type":"object"},"maxItems":9999,"minItems":1,"type":"array","uniqueItems":true},"PropertyListDataResponse":{"type":"object","required":["data"],"additionalProperties":false,"properties":{"data":{"description":"Property distribution list for a chain","type":"array","maxItems":30,"minItems":1,"uniqueItems":true,"items":{"$ref":"#/definitions/propertyData"}}}},"PropertyListDataRequest":{"additionalProperties":false,"properties":{"data":{"type":"array","maxItems":1,"minItems":1,"items":{"$ref":"#/definitions/PropertyCode"}}}},"RatePlanCode":{"description":"rate plan code","example":"BEFLXRATEPLAN001","pattern":"^[A-Z0-9]{1,50}$","type":"string"},"RatePlanDistributions":{"description":"Rate Plan distribution list","items":{"properties":{"pairedARIRatePlanCode":{"$ref":"#/definitions/pairedARIRatePlanCode"},"bookingMessage":{"$ref":"#/definitions/bookingMessage"},"distributionPeriod":{"$ref":"#/definitions/DistributionPeriod"},"distributionRatePlanCode":{"$ref":"#/definitions/DistributionRatePlanCode"},"isActive":{"$ref":"#/definitions/isActive","description":"if true indicates that the rate plan is active for distribution"},"isPublic":{"$ref":"#/definitions/isPublic"},"longRateDescription":{"$ref":"#/definitions/longDescription","description":"Long description of the rate plan"},"maxOccupancy":{"$ref":"#/definitions/MaxOccupancy"},"offers":{"$ref":"#/definitions/Offers"},"rateOverrideThreshold":{"$ref":"#/definitions/rateOverrideThreshold","description":"If authorized, a user can define a threshold (% of the price) per rate plan per channel per property that represent the tolerance of rate discrepancy between the CRS and the channel. The threshold is a percentage on the base rate"},"ratePlanCode":{"$ref":"#/definitions/RatePlanCode"},"ratePlanName":{"$ref":"#/definitions/name","description":"Name of the rate plan"},"sequence":{"$ref":"#/definitions/sequence","description":"unique identifier for each distributed rate plan"},"shortRateDescription":{"$ref":"#/definitions/shortDescription","description":"Short description of the rate plan"}},"required":["ratePlanCode"],"title":"RatePlanDistribution","type":"object"},"maxItems":10000,"minItems":1,"type":"array","uniqueItems":true},"VendorCode":{"description":"unique identifier of a Vendor in a Chain","example":"1AGDS","pattern":"^[A-Z0-9]{5,5}$","type":"string"},"Warning":{"properties":{"code":{"description":"A machine-readable error code from the Canned Messages table, that will enable the API Consumers code to handle this type of error","example":300200,"type":"integer"},"detail":{"description":"An easy-to-read explanation specific to this occurrence of the problem. It should give the API consumer an idea of what went wrong and how to recover from it. Like the title, this field�s value can be localized.","example":"Update to CDE was not successful","type":"string"},"source":{"$ref":"#/definitions/ErrorSource"},"title":{"description":"An error title from the Canned Messages table with a 1:1 correspondence to the error code. This may be localized","example":"Update was not successful","type":"string"}},"required":["code","title"],"type":"object"},"Warnings":{"properties":{"warnings":{"items":{"$ref":"#/definitions/Warning"},"maxItems":999,"type":"array"}},"type":"object"},"action":{"description":"Action of the notification","enum":["Update","Delete"],"type":"string"},"pairedARIRatePlanCode":{"description":"For ETP rate plans, pairedARIRate plan code has the primary rate plan code value used for ARI push","example":"BEFLXRATEPLAN001","pattern":"^[A-Z0-9]{1,50}$","type":"string"},"bookingMessage":{"description":"booking message of the rate plan","maxLength":4000,"minLength":1,"type":"string"},"cmdNotifications":{"description":"List of notification events","items":{"properties":{"action":{"$ref":"#/definitions/action"},"object":{"$ref":"#/definitions/notification"},"type":{"$ref":"#/definitions/type"}},"required":["object","type","action"],"title":"cmdNotification","type":"object"},"type":"array"},"conversationId":{"description":"Unique ID for conversation exchange","type":"string"},"createForDistributedOffers":{"description":"object to define the create op for distribution offers per property","properties":{"inventoryTypeDistributions":{"$ref":"#/definitions/InventoryTypeDistributions"},"ratePlanDistributions":{"$ref":"#/definitions/RatePlanDistributions"}},"type":"object"},"createForDistributedProperty":{"properties":{"propertyDistribution":{"$ref":"#/definitions/PropertyDistribution"},"vendorCode":{"$ref":"#/definitions/VendorCode"}},"required":["propertyDistribution","vendorCode"],"type":"object"},"inventoryDescription":{"description":"description for inventoryType","maxLength":2000,"minLength":1,"type":"string"},"isActive":{"description":"attribute to denote the status","example":true,"type":"boolean"},"isPublic":{"description":"if true, indicates that the rate plan is a public rate plan","example":true,"type":"boolean"},"longDescription":{"description":"long description","maxLength":2000,"minLength":1,"type":"string"},"name":{"description":" name of the associated attribute","maxLength":2000,"minLength":1,"type":"string"},"notification":{"description":"CMD notification object ","properties":{"propertyCode":{"$ref":"#/definitions/PropertyCode"},"vendorCode":{"$ref":"#/definitions/VendorCode"}},"required":["propertyCode","vendorCode"],"type":"object"},"op":{"description":"operation used for the change","enum":["upsert","append","remove"],"type":"string"},"partialUpdateForDistributedOffers":{"properties":{"modificationChanges":{"$ref":"#/definitions/ModificationChanges"},"version":{"$ref":"#/definitions/version"}},"required":["modificationChanges","version"],"type":"object"},"path":{"description":"Path used for the change","type":"string"},"propertyData":{"description":"data retrived per property","type":"object","required":["propertyCode","vendors"],"properties":{"propertyCode":{"$ref":"#/definitions/PropertyCode"},"vendors":{"description":"vendors data distributed to a property for a chain","type":"array","maxItems":46,"minItems":1,"uniqueItems":true,"items":{"$ref":"#/definitions/vendorData"}}}},"rateOverrideThreshold":{"description":"If authorized, a user can define a threshold (% of the price) that represent the tolerance of rate discrepancy between the CRS and the channel. The threshold is a percentage on the base rate","example":8,"maximum":100,"minimum":0,"type":"integer"},"rateData":{"description":"rate plan data retrieved per vendor per property","type":"object","required":["ratePlanCode"],"properties":{"distributionPeriod":{"$ref":"#/definitions/DistributionPeriod"},"offers":{"description":"Inventory type distributed for the rate","type":"array","maxItems":100,"minItems":1,"uniqueItems":true,"items":{"$ref":"#/definitions/reportingOfferData"}},"ratePlanCode":{"$ref":"#/definitions/RatePlanCode"},"ratePlanName":{"$ref":"#/definitions/name","description":"Name of the rate plan"}}},"reportingOfferData":{"description":"Offer data retrieved per rate plan","type":"object","required":["inventoryTypeCode"],"properties":{"inventoryTypeCode":{"$ref":"#/definitions/InventoryTypeCode"}}},"sequence":{"description":"unique identifier for each distributed item","example":91,"maximum":10000,"minimum":1,"type":"integer"},"shortDescription":{"description":"short description","maxLength":2000,"minLength":1,"type":"string"},"success":{"description":"A true boolean to simply show the success of the request.","example":true,"type":"boolean"},"type":{"description":"Type of the notificaiton","enum":["ChannelDistributionStrategy"],"type":"string"},"updateForDistributedProperty":{"properties":{"propertyDistribution":{"$ref":"#/definitions/PropertyDistribution"},"version":{"$ref":"#/definitions/version"}},"required":["propertyDistribution","version"],"type":"object"},"value":{"description":"The json structure (not a string, i.e. without opening and closing quotes) to be inserted at the specified path"},"vendorData":{"description":"data retrieved per vendor per property","type":"object","required":["vendorCode"],"properties":{"vendorCode":{"$ref":"#/definitions/VendorCode"},"vendorTypeCodes":{"type":"array","maxItems":6,"minItems":1,"items":{"$ref":"#/definitions/vendorTypeCode"}},"ratePlans":{"description":"Rate Plan distribution list for a vendor & property","type":"array","maxItems":1000,"minItems":1,"uniqueItems":true,"items":{"$ref":"#/definitions/rateData"}}}},"vendorTypeCode":{"description":"Vendor type identifier for a vendorCode","example":5,"maximum":6,"minimum":1,"type":"integer"},"version":{"description":"record's version","example":1,"type":"integer"}}}